#ifndef CAMERA_H
#define CAMERA_H      

/******************************************************************************
	File:			CCamera.h
	Description:		Implementation of the CCamera class
	Class:			CCamera
	Author:			AR1795 (10/14/05)							  
	Copyright (C) 2005 AR1795                                                                   
******************************************************************************/

#include "config.h"   


class CCamera  
{                          
public:
	enum EState {IDLE, ARMED, CAPTURE, READY};	
private:
	enum {MIN_INTEGRATION_TIME = 4102, MAX_INTEGRATION_TIME = 10000};
	enum {DEFAULT_INTEGRATION_TIME = MIN_INTEGRATION_TIME + 32};                  
	WORD m_wIntegrationTime;              
	
	enum {CAMERA_CLK_PERIOD	= 74UL}; // 10 us
	enum {ST_PALSE_WIDTH = 0};
	
	static EState s_eState;

public:
	enum {IMAGE_SIZE = 1024};
	static WORD s_wPixelCounter;
	static BYTE s_vbyPixels[IMAGE_SIZE];
public:
	CCamera();
	void Start();    
	BOOL IsReady();
	WORD Read (); 
	void Reset ();
	
	static void Write (WORD a_wPixel);
	static void SetState (EState a_eState);
        static EState GetState ();
	WORD GetImageSize (){return IMAGE_SIZE;}
	WORD SetIntgrationTime (WORD a_wTime);                
	WORD GetIntegrationTime () {return m_wIntegrationTime;} 
};

inline void CCamera::SetState (CCamera::EState a_eState)
{
	s_eState = a_eState;
}
inline CCamera::EState CCamera::GetState ()
{
	return s_eState;
}

inline BOOL CCamera::IsReady()
{
	return (s_eState == READY)?TRUE:FALSE;
}

#endif // CAMERA_H
