/******************************************************************************
	File:			main.cpp
	Description:		main function of the application
	Class:			none
	Author:			AR1795 (10/14/05)							  
	Copyright (C) 2005 AR1795                                                                   
******************************************************************************/

#include "Camera.h"
#include "Filter.h"

extern "C" int main(void);
int main (void) 
{
  CCamera Camera;
  CFilter Filter;

  __ARMLIB_enableIRQ();
  while(true)
  {
    /* start image capturing */
    Camera.Start();
    /* wait till the image is ready */
    while (false == Camera.IsReady());
    /* calculate image position */
    unsigned short wLinePosition = Filter.Calculate((const unsigned char*)CCamera::s_vbyPixels, CCamera::IMAGE_SIZE);
    /* output line position as voltage */
    DACR = (wLinePosition & 0x3FF) << 6;
  }
  return 0;
}
