#ifndef TYPES_H
#define TYPES_H       

/******************************************************************************
	File:			Types.h											  
	Description:		Basic Type Definitions                               
	Class:			None
	Author:			AR1795 (10/14/05)							  
	Copyright (C) 2005 AR1795                                                                   
******************************************************************************/

typedef unsigned char		BYTE;
typedef unsigned short		WORD;
typedef unsigned long		DWORD;
typedef unsigned char		BOOL;

typedef union
{
    BYTE m_byByte[2];
    WORD m_wWord;
} UWORD;

typedef union
{
    BYTE m_byByte[4];
    WORD m_wWord[2];
    DWORD m_dwDWord;
} ULWORD;
            
#ifndef NULL
#define NULL    			0
#endif


#ifndef FALSE
#define FALSE               0
#endif

#ifndef TRUE
#define TRUE                1
#endif

#define MAKEWORD(a, b)      ((WORD)(((BYTE)(a)) | ((WORD)((BYTE)(b))) << 8))
#define MAKELONG(a, b)      ((LONG)(((WORD)(a)) | ((DWORD)((WORD)(b))) << 16))
#define MAKEDWORD(a, b)     ((DWORD)(((WORD)(a)) | ((DWORD)((WORD)(b))) << 16))
#define LOWORD(l)           ((WORD)(l))
#define HIWORD(l)           ((WORD)(((DWORD)(l) >> 16) & 0xFFFF))
#define LOBYTE(w)           ((BYTE)(w))
#define HIBYTE(w)           ((BYTE)(((WORD)(w) >> 8) & 0xFF))
#define LONIBBLE(b)         ((BYTE)(b&0x0F))
#define HINIBBLE(b)         ((BYTE)(((BYTE)(b) >> 4) & 0x0F))

#define min(a, b)	(((a) < (b))?(a):(b))
#define max(a, b)	(((a) > (b))?(a):(b))
#define abs(a)		(((a) > 0)?(a):(-(a)))

// File access modes
enum EMode 
{   
	MODE_CLOSED = 0x00,
	MODE_READ = 0x01,
	MODE_WRITE = 0x02,
	MODE_BINARY = 0x04
};

enum EAccessRights {PUBLIC, PROTECTED, PRIVATE};

#endif /* TYPES_H */
